
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglRec.h"
#include "pgl/AddrMapSym.h"


AddrMapSym::AddrMapSym(): RecSym("AddrMap", new PglRec) {
	theRec->bAdd("addr[]", "addresses", 0);
	theRec->bAdd("addr[]", "names", 0);
}

AddrMapSym::AddrMapSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool AddrMapSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "AddrMap";
}

SynSym *AddrMapSym::dupe(const String &type) const {
	if (isA(type))
		return new AddrMapSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}

bool AddrMapSym::addresses(Array<NetAddr*> &addrs) const {
	return getNetAddrs("addresses", addrs);
}

bool AddrMapSym::names(Array<NetAddr*> &nms) const {
	return getNetAddrs("names", nms);
}
