
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "pgl/AgentSym.h"
#include "pgl/AgentArrIter.h"


AgentArrIter::AgentArrIter(CfgSyms &aCfgSyms, const Addrs *aLocalAddrs, const String &anAgentType):
	theAgentType(anAgentType) {
	theCfgs = aCfgSyms; 
	start(aLocalAddrs);
}

AgentSym *AgentArrIter::agentSym() {
	return &(AgentSym&)cfgSym(theCfgIdx)->cast(theAgentType);
}

HostsBasedSym *AgentArrIter::cfgSym(int idx) const {
	return theCfgs[idx];
}

int AgentArrIter::cfgCount() const {
	return theCfgs.count();
}

bool AgentArrIter::belongs(const HostsBasedSym *cfgSym, const NetAddr &host) const {
	return cfgSym->isA(theAgentType) &&
		HostsBasedIter::belongs(cfgSym, host);
}
