
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglIntSym.h"
#include "pgl/PglRec.h"
#include "pgl/PglStringSym.h"
#include "pgl/ConsoleSym.h"


ConsoleSym::ConsoleSym(const String &aType): RecSym(aType, new PglRec) {

	// add fields

	theRec->bAdd("string", "fname", 0);
	theRec->bAdd("int", "verb_lvl", 0);
}

ConsoleSym::ConsoleSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool ConsoleSym::isA(const String &type) const {
	return RecSym::isA(type) ||	type == "Console";
}

SynSym *ConsoleSym::dupe(const String &type) const {
	if (isA(type))
		return new ConsoleSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}
