
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_OBJECT_LIFE_CYCLE_SYMBOL_H
#define PGL_OBJECT_LIFE_CYCLE_SYMBOL_H

#include "xstd/Array.h"
#include "pgl/PglRecSym.h"

class QualifSym;

// parameters for object life cycle model
class ObjLifeCycleSym: public RecSym {
	public:
		ObjLifeCycleSym();
		ObjLifeCycleSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		RndDistr *bday() const;
		RndDistr *length() const;
		bool variance(double &ratio) const;
		bool withLmt(double &ratio) const;
		bool expires(Array<RndDistr*> &times, RndDistr *&selector, Array<QualifSym*> &qs) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
