
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CONNECTION_MANAGER_H
#define PG_CONNECTION_MANAGER_H

#include "xstd/FileScanner.h"
#include "runtime/Farm.h"
#include "runtime/Connection.h"
#include "runtime/ConnIdx.h"

class RndDistr;

// interface for managing agent connections
class ConnMgr: public FileScanner::User {
	protected:
		typedef ConnCloseStat::CloseKind CloseKind;

	public:
		ConnMgr();

		void configure(const SockOpt &anOpt, RndDistr *aPconnUseLmt);
		void idleTimeout(Time aTout);

		// return used connection
		void put(Connection *conn);

		virtual void noteTimeout(int fd, Time tout);

	protected:
		virtual void putIdle(Connection *conn);
		virtual void delIdle(Connection *) {}
		
		void opened(Connection *conn);
		void setUseLimit(Connection *conn);
		void closeIdle(Connection *conn, CloseKind ck);
		void closeBusy(Connection *conn);

	private:
		void close(Connection *conn);

	protected:
		static ObjFarm<Connection> TheConnFarm;
		static ConnIdx TheConnIdx; // shared fd -> conn map
	
		SockOpt theSockOpt;
		RndDistr *thePconnUseLmt;
		Time theIdleTimeout;

		int theConnLvl;       // all opened connections
		int theIdleConnLvl;   // idle connections
};

#endif
