
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_HTTP_TEXT_H
#define PG_HTTP_TEXT_H

#include "xstd/String.h"

// various HTTP header strings


// request line parts
extern const String rlpGet;
extern const String rlpHttp_10;

// status lines
extern const String slHttp_10_200;
extern const String slHttp_10_302;
extern const String slHttp_10_304;

// full header fields
extern const String hfAccept;
extern const String hfConnAliveOrg;
extern const String hfConnCloseOrg;
extern const String hfConnAlivePxy;
extern const String hfConnClosePxy;
extern const String hfReload;
extern const String hfCcCachable;
extern const String hfCcUncachable;

// header field prefixes
extern const String hfpHost;
extern const String hfpIMS;
extern const String hfpXLocWorld;
extern const String hfpXRemWorld;
extern const String hfpXXact;
extern const String hfpXTarget;
extern const String hfpXPhaseSyncPos;
extern const String hfpContLength;
extern const String hfpContType;
extern const String hfpDate;
extern const String hfpExpires;
extern const String hfpLmt;
extern const String hfpLocation;
extern const String hfpXRemWorld;
extern const String hfpXXact;
extern const String hfpXTarget;

// free text
extern const String text302Found;

#endif
