
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CLIENT_GROUP_GLOBAL_MAP_H
#define PG_CLIENT_GROUP_GLOBAL_MAP_H

#include "xstd/Array.h"

class UniqId;
class CltGrpGlobRep;

// a GroupId <-> CltGrpGlobRep map
// add-only operation
// per polysrv information
class CltGrpGlobMap {
	public:
		CltGrpGlobMap();
		~CltGrpGlobMap();

		int capacity() const { return theIndex.capacity(); }
		int count() const { return theCount; }

		int phaseSyncPos() const { return thePhaseSyncPosMin; }

		void notePhaseSync(const UniqId &grp, int pos);

	protected:
		bool find(const UniqId &group, int &idx) const;
		CltGrpGlobRep *addAt(int idx, const UniqId &group);
		bool endSearch(const UniqId &group, int idx, bool &res) const;

	protected:
		Array<CltGrpGlobRep*> theIndex;
		int theCount;       // entries in the index

		int thePhaseSyncPosMin; // phase schedule pos of the slowest group
};

extern CltGrpGlobMap TheCltGrpGlobMap;

#endif
