
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef XSTD_RESOURCE_USAGE_H
#define XSTD_RESOURCE_USAGE_H

#include "xstd/Time.h"
#include "xstd/String.h"
#include "xstd/h/sys/resource.h"

class ostream;

// a wrapper arround highly unportable "getrusage()" system call
class ResourceUsage: protected rusage {
	public:
		static ResourceUsage Current(); // current rusage

	public:
		ResourceUsage();

		Time sysTime() const;
		Time userTime() const;
		Time cpuTime() const;
		Size maxResSize() const;
		long physPageFaults() const;

		bool update(); // syncronize with current usage

		void report(ostream &os, const String &pfx) const;
};


inline
ostream &operator <<(ostream &os, const ResourceUsage &ru) {
	ru.report(os, "");
	return os;
}

#endif
