
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef XSTD_SOURCE_LOCATION_H
#define XSTD_SOURCE_LOCATION_H

#include "xstd/String.h"

#define Here SrcLoc(__FILE__, __LINE__)

class ostream;

// source location holder
class SrcLoc {
	public:
		SrcLoc(const String &aFname = 0, int aLineNo = 1);

		int lineno() const { return theLineNo; }
		const String &fname() const { return theFName; }

		operator void*() const { return theFName ? (void*)-1 : 0; }
		SrcLoc &operator ++() { ++theLineNo; return *this; }
		bool sameLine(const SrcLoc &t) const;

		ostream &print(ostream &os) const;

	protected:
		String theFName;
		int theLineNo;
};

inline ostream &operator <<(ostream &os, const SrcLoc &l) { return l.print(os); }

#endif
